/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * ESP32 - BT - Peso
*/


#define TPESO 25

//_____HX711______________
#include "HX711.h"
const int DOUT=16;
const int CLK=17;
HX711 balanza;

float peso;
#define AJUSTE 1977700
char L4_peso[25];

//_____Bluetooth____________
#include "BluetoothSerial.h"
BluetoothSerial SerialBT;


#define PIN_LED 2

char VARI[100];
char mibuffer[20];
char TITULO[]="PESO_BT_seta";
int timePeso=TPESO;


void setup()
{  Serial.begin(115200);
   Serial.println(TITULO);
   pinMode(PIN_LED, OUTPUT);
   
   SerialBT.begin(TITULO); //Bluetooth device name
   Serial.println("The device started, now you can pair it with bluetooth!");

   balanza.begin(DOUT, CLK);
    Serial.println("No ponga ningún objeto sobre la balanza");
    Serial.print("VALOR ADC:tara ->");
    Serial.println(balanza.read());
    balanza.set_scale(AJUSTE); //La escala por defecto es 1
    balanza.tare(10);  // Establecemos la tara    
   delay(500);
}

void loop()
{
 char c;
 int z;
 
  delay(20);
  timePeso++; 
  if(timePeso>TPESO)
    {
      timePeso=0;
      digitalWrite(PIN_LED, 1);
      getPeso();
      digitalWrite(PIN_LED, 0);
      for(z=0;z<25;z++) 
        {         
          if(L4_peso[z]==0)
            {
              SerialBT.write(13); SerialBT.write(10);
              break;
            }
         SerialBT.write(L4_peso[z]);
        }
    }  
    
  if ( Serial.available())
        SerialBT.write(Serial.read());
  if (SerialBT.available())
     Serial.write(SerialBT.read());

}



//_____________PESO______________

void getPeso(void)
{
 int32_t z;
  peso=balanza.get_units(10);  //numero de lecturas para hacer la media
  z=peso*10000;
  intTOstring(z,4,1); 
  //sprintf(L4_peso,"Peso: %s grs ",mibuffer); 
  sprintf(L4_peso,"%s grs ",mibuffer); 
  Serial.println(L4_peso);
}


//_SETA43__
void intTOstring(int n,unsigned char dig,unsigned char dec)
{
  int z,x,zz;
  char signo;

  zz=0;
  z=10000;
 // if(n<0) { signo='-'; n*=-1;}  else  {signo='+'; }
  if(n<0) { signo='-'; n*=-1;}  else  {signo=' '; }
  mibuffer[zz]=signo; zz++;
  for(;z>0;z=z/10)
  {
    x=n/z;
    n=n-(z*x);
    mibuffer[zz]=x+'0';
    zz++;
  }
  mibuffer[zz]=0;
  
  if(dec!=0)
   {
    x=zz+1;
    for(;zz>=0;zz--)
    {
    mibuffer[x]=mibuffer[zz];
    x--;
    if(0==dec) { mibuffer[x]='.'; x--;} 
    dec--;
    }
   }
}
